import scala.annotation.tailrec

class Rational(n: Int, d: Int) {
  require(d != 0)

  @tailrec
  private def gcd(x: Int, y: Int): Int =
    if (y == 0) x else gcd(y, x % y)

  private val g: Int = gcd(n, d)
  def num: Int = n / g
  def denom: Int = d / g


  def +(that: Rational): Rational = new Rational(
    this.num * that.denom + this.denom * that.num,
    this.denom * that.denom
  )

  def unary_- : Rational = new Rational(-num, denom)

  def <(that: Rational): Boolean = this.num * that.denom < that.num * this.denom

  def max(that: Rational): Rational = if (this < that) that else this

  override def toString = if (math.abs(denom) == 1) "" + denom else num + "/" + denom
}

val r1 = new Rational(1, 3)
val r2 = new Rational(2, 3)
val r3 = r1 + r2

r3

-r2

r2 < r1
r2 < r3

r2.max(r1)
r2.max(r3)